<!DOCTYPE html>
<html>
<head>
	<title>Objects</title>
</head>
<body>
	<script type="text/javascript">
		/*
			Objects:
			Booleans
			Dates
			Math
			String
			Regular Expressions
			Arrays
			Functions
			Objects

			Primitives:
			string
			boolean
			number
			null
			undefined
		*/	

		var x1 = new Boolean();
		var x2 = new Date();
		var x3 = new String();
		var x4 = new RegExp();
		var x5 = new Array();
		var x6 = new Function();
		var x7 = new Object();
		var x8 = new Number();
		//Math is a global object its instance cannot be created

		var persons = "John Doe";
		var person = {firstname: 'John', lastname: 'Doe', age: 30, eyecolor:'blue', fullname: function(){
			return this.firstName + " " + this.lastname;
		}};
		/*
			php : Associative arrays
			python : Dictionaries
			C : Hash Tables
			Java : Hash Maps
			Ruby and Perl : Hashes
		*/

		/*
			name value pair will have a property and a value
		*/


		//3 ways to create objects
		//1) object literal
		console.log("==========Object Literal=============");
		var personSmarter = {firstname: 'John', 
						lastname: 'Doe', 
						age: 30, 
						eyecolor:'blue'};
		console.log(personSmarter);

		//2)new Keyword
		console.log("==========Using new Keyword=============");
		var personSmarterThanSmarter = new Object();
		personSmarterThanSmarter.firstname = "John";
		personSmarterThanSmarter.lastname = "Doe";
		console.log(personSmarterThanSmarter);
		//3)Constructor
		function personobj(first, last, age, eye){
			this.firstname = first;
			this.lastname = last;
			this.age = age;
			this.eyecolor = eye;
		}
		var mother = new personobj("Jenny", "Doe", 70, "black");
		console.log(mother);

		//Object Properties
		console.log("==========Object Properties=============");
		person = {firstname: 'John', lastname: 'Doe', age: 30, eyecolor:'blue'};
		//properties can be added, changed or deleted
		/*
			there are 3 ways to access properties
			objectName.property
			objectName['property']
			objectName[expression] : eg: var x = "propertyName"; 
										 person[x]
		*/
		var x = "age";
		console.log(person.firstname);
		console.log(person['lastname']);
		console.log(person[x]);

		/*
			for(variable in object){
				code
			}
		*/
		var text = "";
		for(y in person){
			text += person[y];
			text += " ";
		}
		console.log(text);

		//adding a property
		person.nationality = "Indian";
		console.log(person.nationality);

		//deleting property
		delete person.age;
		console.log(person);
		//Do not use delete on javascripts pre defined objects


		//In the name value pair the value is one of the properties attribute. Other attributes are enumberable, configurable and writable.


		console.log("\n\n==========Object Methods==========");
		/*
			methodname : fuinction(){
				code...
			}

			objectName.methodName();
		*/
		person = {firstname: 'John', 
				lastname: 'Doe', 
				age: 30, 
				eyecolor:'blue',
				fullName : function(){
					return this.firstname + " " + this.lastname;
				}};
		console.log(person.fullName());
		//methods cannot be added on the go

		console.log("\n\n==========Object Prototype==========");
		//all objects are created from the main parent Object.prototype
		//new Date -> Date.prototype
		function Person(first, last, age, eyecolor){
			this.firstname = first;
			this.lastname = last;
			this.age = age;
			this.eyecolor = eyecolor;
		}
		var myFather = new Person("Daniel", "Dcruz", 60, "black");
		var myMother = new Person("Martha", "Dcruz", 60, "black");
		console.log(myFather);
		myFather.nationality = "English";
		myFather.name = function(){
			return this.firstname + " " + this.lastname;
		};
		console.log(myFather.name());

		console.log("Nationality of mother : " + myMother.nationality);
		Person.prototype.nationality = "English";
		console.log("Nationality of mother after adding attribute as prototype : " + myMother.nationality);
	</script>

</body>
</html>